#!/usr/bin/perl

# DSPAM
# COPYRIGHT (C) 2003 NETWORK DWEEBS CORPORATION
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

use strict;
use vars qw { %CONFIG %DATA %FORM $MAILBOX $USER };
require "ctime.pl";

## Configuration
#
$CONFIG{'USERDIR'} = "/etc/mail/dspam";
$CONFIG{'ME'} = "dspam.cgi";
$CONFIG{'DSPAM'} = "/usr/local/bin/dspam";
$CONFIG{'DSPAM_ARGS'} = "--user $ENV{'REMOTE_USER'} -d %u";
$CONFIG{'LARGE_SCALE'} = 0;
$CONFIG{'SPAM_ACCOUNT'} = "spam-$ENV{'REMOTE_USER'}\@yourdomain.com";
#
## End Configuration

if ($CONFIG{'LARGE_SCALE'} == 0) {
  $USER = "$CONFIG{'USERDIR'}/$ENV{'REMOTE_USER'}/$ENV{'REMOTE_USER'}";
  $MAILBOX = "$CONFIG{'USERDIR'}/$ENV{'REMOTE_USER'}/$ENV{'REMOTE_USER'}.mbox";
} else {
  if (length($ENV{'REMOTE_USER'})>1) {
    $USER = "$CONFIG{'USERDIR'}/" . substr($ENV{'REMOTE_USER'}, 0, 1) . "/".
      substr($ENV{'REMOTE_USER'}, 1, 1) . "/$ENV{'REMOTE_USER'}/$ENV{'REMOTE_USER'}";
  } else {
    $USER = "$CONFIG{'USERDIR'}/$ENV{'REMOTE_USER'}/$ENV{'REMOTE_USER'}";
  }
}

$MAILBOX = "$USER.mbox";

%FORM = &ReadParse;

if ($ENV{'REMOTE_USER'} eq "") { 
  &error("System Error. I was unable to determine what username you are.");
}

&Welcome if ($FORM{'COMMAND'} eq "");
&ViewSpam if ($FORM{'COMMAND'} eq "VIEW_SPAM");
&ViewOneSpam if ($FORM{'COMMAND'} eq "VIEW_ONE_SPAM");
&DeleteSpam if ($FORM{'COMMAND'} eq "DELETE_SPAM");
&NotSpam if ($FORM{'COMMAND'} eq "NOTSPAM");
&AddAlert if ($FORM{'COMMAND'} eq "ADD_ALERT");
&DeleteAlert if ($FORM{'COMMAND'} eq "DELETE_ALERT");
&ResetStats if ($FORM{'COMMAND'} eq "RESET_STATS");
&Tweak if ($FORM{'COMMAND'} eq "TWEAK");

&error("Invalid Command: $FORM{'COMMAND'}");

sub AddAlert {
  if ($FORM{'ALERT'} eq "") {
    &error("No Alert Specified");
  }
  open(FILE, ">>$USER.alerts");
  print FILE "$FORM{'ALERT'}\n";
  close(FILE);
  return &Welcome;
}

sub DeleteAlert {
  my($line, @alerts);
  $line = 0;
  if ($FORM{'line'} eq "") {
    &Error("No Alert Specified");
  }
  open(FILE, "<$USER.alerts");
  while(<FILE>) {
    if ($line != $FORM{'line'}) {
      push(@alerts, $_);
    }
    $line++;
  }
  close(FILE);

  open(FILE, ">$USER.alerts");
  foreach(@alerts) { print FILE $_; }
  close(FILE);
  return &Welcome;
}

sub NotSpam {
  my(@buffer);
  if ($FORM{'MESSAGE_ID'} eq "") {
    &error("No Message ID Specified");
  }
  open(FILE, "<$MAILBOX");
  while(<FILE>) {
    chomp;
    push(@buffer, $_);
  }
  close(FILE);

  open(PIPE, "|$CONFIG{'DSPAM'} $CONFIG{'DSPAM_ARGS'} --falsepositive") || &error($!);
  while($#buffer>=0) {
    my($buff, $mode, @temp, %head);
    $mode = 0;
    @temp = ();
    while(($buff !~ /^From /) && ($#buffer>=0)) {
      $buff = $buffer[0];
      if ($buff =~ /^From /) {
        if ($mode == 0) { $mode = 1; }
        else { next; }
      }
      $buff = shift(@buffer);
      if ($buff !~ /^From /) {
        push(@temp, $buff);
      }
      next;
     }
     foreach(@temp) {
       last if ($_ eq "");
       my($key, $val) = split(/\: ?/, $_, 2);
       $head{$key} = $val;
     }
     $head{'Message-ID'} = $head{'Message-Id'} if ($head{'Message-ID'} eq "");
     $head{'Message-ID'} = $head{'X-DSPAM-Signature'} if ($head{'Message-ID'} eq "");
     if ($head{'Message-ID'} eq $FORM{'MESSAGE_ID'}) {
       foreach(@temp) {
       print PIPE "$_\n";
     }
   }
 }
 close(PIPE);
 $FORM{$FORM{'MESSAGE_ID'}} = "on";
 &DeleteSpam();
 print "Location: $CONFIG{'ME'}?COMMAND=VIEW_SPAM\n\n";
 exit;
}

sub ViewOneSpam {
  my(@buffer);
  if ($FORM{'MESSAGE_ID'} eq "") {
    &error("No Message ID Specified");
  }
  open(FILE, "<$MAILBOX");
  while(<FILE>) {
    chomp;
    push(@buffer, $_);
  }
  close(FILE);

  $DATA{'MESSAGE'} = <<_END;
<FORM ACTION="$CONFIG{'ME'}">
<INPUT TYPE=HIDDEN NAME=MESSAGE_ID VALUE="$FORM{'MESSAGE_ID'}">
<INPUT TYPE=HIDDEN NAME=COMMAND VALUE="NOTSPAM">
<CENTER>
<INPUT TYPE=SUBMIT VALUE="THIS IS NOT SPAM!">
</CENTER>
</FORM>
<BR>
<PRE>
_END
  while($#buffer>=0) {
    my($buff, $mode, @temp, %head);
    $mode = 0;
    @temp = ();
    while(($buff !~ /^From /) && ($#buffer>=0)) {
      $buff = $buffer[0];
      if ($buff =~ /^From /) {
        if ($mode == 0) { $mode = 1; }
        else { next; }
      }
      $buff = shift(@buffer);
      if ($buff !~ /^From /) {
        push(@temp, $buff);
      }
      next;
    }
    foreach(@temp) {
      last if ($_ eq "");
      my($key, $val) = split(/\: ?/, $_, 2);
      $head{$key} = $val;
    }
    $head{'Message-ID'} = $head{'Message-Id'} if ($head{'Message-ID'} eq "");
    $head{'Message-ID'} = $head{'X-DSPAM-Signature'} if ($head{'Message-ID'} eq "");
    if ($head{'Message-ID'} eq $FORM{'MESSAGE_ID'}) {
      foreach(@temp) {
        s/</\&lt\;/g;
        s/>/\&gt\;/g;
        $DATA{'MESSAGE'} .= "$_\n";
      }
    }
  }
  $DATA{'MESSAGE'} .= "</PRE>";
  &output(%DATA);
}

sub DeleteSpam {
  my(@buffer);
  if ($FORM{'delete_all'} ne "") {
    my($sz);

    my($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
     $atime,$mtime,$ctime,$blksize,$blocks)
     = stat("$USER.mbox");
                                                                                
    open(FILE, "<$USER.mbox.size");
    $sz = <FILE>;
    close(FILE); 
    chomp($sz);

    if ($sz == $size) {
      open(FILE, ">$MAILBOX");
      close(FILE);
      unlink("$USER.mbox.size");
      unlink("$USER.mboxwarn");
    } else {
      return &ViewSpam;
    }
  }
  open(FILE, "<$MAILBOX");
  while(<FILE>) {
    chomp;
    push(@buffer, $_);
  }
  close(FILE);
 

  open(FILE, ">$MAILBOX");
 
  while($#buffer>=0) {
    my($buff, $mode, @temp, %head);
    $mode = 0;
    while(($buff !~ /^From /) && ($#buffer>=0)) {
      $buff = $buffer[0];
      if ($buff =~ /^From /) {
        if ($mode == 0) { 
          $mode = 1; 
          $buff = shift(@buffer); 
          push(@temp, $buff); 
          $buff = ""; 
          next; 
        } else { 
          next; 
        }
      }
      $buff = shift(@buffer);
      push(@temp, $buff);
      next;
    }
    foreach(@temp) {
      last if ($_ eq "");
      my($key, $val) = split(/\: ?/, $_, 2);
      $head{$key} = $val;
    }
    $head{'Message-ID'} = $head{'Message-Id'} if ($head{'Message-ID'} eq "");
    $head{'Message-ID'} = $head{'X-DSPAM-Signature'} if ($head{'Message-ID'} eq "");
    if ($FORM{$head{'Message-ID'}} eq "") {
      foreach(@temp) {
        print FILE "$_\n";
      }
    }
  }
  close(FILE);
  print "Location: $CONFIG{'ME'}?COMMAND=VIEW_SPAM\n\n";
  exit;
}

sub ViewSpam {
  my(@alerts);

  my($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
   $atime,$mtime,$ctime,$blksize,$blocks)
   = stat("$USER.mbox");

  open(FILE, ">$USER.mbox.size");
  print(FILE "$size");
  close(FILE);

  open(FILE, "<$USER.alerts");
  while(<FILE>) {
    chomp;
    push(@alerts, $_);
  }
  close(FILE);

  $DATA{'MESSAGE'} = <<_END;
<FORM ACTION="$CONFIG{'ME'}" METHOD="GET">
<InPUT TYPE=HIDDEN NAME=COMMAND VALUE=DELETE_SPAM>
<B>SPAM Blackhole: Email Quarantine</B><BR>
<A HREF="$CONFIG{'ME'}">Click Here to Return</A><BR>
<BR>
<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0>
<TR><TD BGCOLOR=#000000><FONT COLOR=#FFFFFF SIZE=-1><B>&nbsp;DEL&nbsp;</B></FONT>&nbsp;&nbsp;</TD>
    <TD BGCOLOR=#000000><FONT COLOR=#FFFFFF SIZE=-1><B>&nbsp;SENT&nbsp;</B></FONT>&nbsp;&nbsp;</TD>
    <TD BGCOLOR=#000000><FONT COLOR=#FFFFFF SIZE=-1><B>&nbsp;FROM&nbsp;</B></FONT>&nbsp;&nbsp;</TD>
    <TD BGCOLOR=#000000><FONT COLOR=#FFFFFF SIZE=-1><B>&nbsp;SUBJECT&nbsp;</B></FONT>&nbsp;&nbsp;</TD>
</TR>
_END

  my($next, @buffer, $bgcolor, $mode);
  open(FILE, "<$MAILBOX");
  while(<FILE>) {
    chomp;
    if ($_ ne "") {
      if ($mode eq "") { 
        if ($_ =~ /^From /) {
          $mode = 1;
        } else { 
          next; 
        } 
      }
      push(@buffer, $_);
      next;
    }
    next if ($mode eq "");

    my(%heading, $start, $alert);
    $alert = 0;
    foreach(@buffer) {
      my($al);
      foreach $al (@alerts) {
        if (/$al/i) {
          $alert = 1;
        }
      }
      if ($_ =~ /^From /) {
        my(@a) = split(/ /, $_);
        my($x) = 2;
        for (0..$#a) { 
          if (($a[$_] =~ /\@|>/) && ($_>$x)) { 
            $x = $_ + 1;
          }
        }
        for(1..$x) { shift(@a); }
        $start = join(" ", @a);
      } else {
        my($key, $val) = split(/\: ?/, $_, 2);
        $heading{$key} = $val; 
      }
    }
    if ($bgcolor eq "FFFFFF") { 
      $bgcolor = "BBBBBB"; 
    } else { 
      $bgcolor = "FFFFFF"; 
    }

    if ($alert) { $bgcolor="FFFF00"; }

    $heading{'Sub2'} = $heading{'X-DSPAM-Signature'};
    if (length($heading{'Subject'})>40) {
      $heading{'Subject'} = substr($heading{'Subject'}, 0, 37) . "...";
    } 
 
    if (length($heading{'From'})>40) {
      $heading{'From'} = substr($heading{'From'}, 0, 37) . "...";
    }

    if ($heading{'Subject'} eq "") {
      $heading{'Subject'} = "<None Specified>";
    }

    $heading{'Message-ID'} = $heading{'Message-Id'} if ($heading{'Message-ID'} eq "");
    $heading{'Message-ID'} = $heading{'Sub2'} if ($heading{'Message-ID'} eq "");

    foreach(keys(%heading)) {
      next if ($_ eq "Message-ID");
      $heading{$_} =~ s/</\&lt\;/g;
      $heading{$_} =~ s/>/\&gt\;/g;
    }

    my(%PAIRS);
    $PAIRS{'MESSAGE_ID'} = $heading{'Message-ID'};
    $PAIRS{'COMMAND'} = "VIEW_ONE_SPAM";
    my($url) = &SafeVars(%PAIRS);

    $DATA{'MESSAGE'} .= <<_END;
<TR>
 <TD BGCOLOR=#$bgcolor><NOBR><FONT SIZE=-1>&nbsp;
   <INPUT TYPE=CHECKBOX NAME="$heading{'Message-ID'}">&nbsp;</B></FONT>
   &nbsp;&nbsp;</TD>
 <TD BGCOLOR=#$bgcolor><NOBR><FONT SIZE=-1>&nbsp;$start&nbsp;</B></FONT>
   &nbsp;&nbsp;</TD>
 <TD BGCOLOR=#$bgcolor><NOBR><FONT SIZE=-1>&nbsp;$heading{'From'}&nbsp;</B></FONT>
   &nbsp;&nbsp;</TD>
 <TD BGCOLOR=#$bgcolor><NOBR><FONT SIZE=-1>&nbsp;<A HREF="$CONFIG{'ME'}?$url">$heading{'Subject'}</A>&nbsp;</B>
   </FONT>&nbsp;&nbsp;</TD>
</TR>
_END
    @buffer = ();
    $mode = "";
    next;
  } 

  $DATA{'MESSAGE'} .= <<_END;
</TABLE>
<BR><INPUT TYPE=SUBMIT VALUE="Delete Checked">
&nbsp;<INPUT TYPE=SUBMIT VALUE="Delete All" NAME=delete_all>
</FORM>
_END
  &output(%DATA);
}

sub ResetStats {
  my($stats);
  open(FILE, "<$USER.stats");
  chomp($stats = <FILE>);
  close(FILE);
  open(FILE, ">$USER.rstats");
  print FILE "$stats\n";
  close(FILE);
  print "Location: $CONFIG{'ME'}?\n\n";
  exit;
}

sub Tweak {
  my($ts, $ti, $tm, $fp, $sc, $ic);
  open(FILE, "<$USER.rstats");
  chomp($ts = <FILE>);
  close(FILE);
  ($ts, $ti, $tm, $fp, $sc, $ic) = split(/\,/, $ts);
  $tm++;
  open(FILE, ">$USER.rstats");
  print FILE "$ts,$ti,$tm,$fp,$sc,$ic\n";
  close(FILE);
  print "Location: $CONFIG{'ME'}?\n\n";
  exit;
}

sub Welcome {
  my($spam, $innocent, $ratio, $fp, $misses);
  my($rts, $rti, $rtm, $rfp, $sc, $ic, $overall, $fpratio, $monthly, $real_missed, $real_caught, $real_fp, $real_innocent);
  my($time) = ctime(time);

  open(FILE, "<$USER.stats");
  chomp($spam = <FILE>);
  close(FILE);
  ($spam, $innocent, $misses, $fp, $sc, $ic) = split(/\,/, $spam);

  # Prepare Welcome Header
  if ($spam+$innocent>0) { 
    $ratio = sprintf("%3.2f", (($spam+$misses)/($spam+$misses+$fp+$innocent)*100)); 
  } else { 
    $ratio = 0; 
  }

  if (open(FILE, "<$USER.rstats")) {
    my($rstats);
   
    chomp($rstats = <FILE>);
    ($rts, $rti, $rtm, $rfp) = split(/\,/, $rstats);
    close(FILE);
    $real_missed = $misses-$rtm;
    $real_caught = $spam-$rts;
    $real_fp = $fp-$rfp;
    $real_innocent = $innocent-$rti; 
    if ($spam-$rts > 0) {
      $monthly = sprintf("%2.3f", (100-(($misses-$rtm)/(($spam-$rts)+($misses-$rtm)))*100));
      $overall = sprintf("%2.3f", (100-((($real_missed+$real_fp) / ($real_fp+$real_innocent+$real_caught+$real_missed))*100)));
    } else {
      $monthly = 100;
      $overall = 100;
    }

    if ($real_fp+$real_innocent>0) {
      $fpratio = sprintf("%2.3f", ($real_fp/($real_fp+$real_innocent)*100));
    } else {
      $fpratio = 0;
    }

  } else {
    $rts = $spam+$misses;
    $rti = $innocent;
    $rtm = $misses;
    $rfp = $fp;
    open(FILE, ">$USER.rstats");
    print FILE "$rts,$rti,$rtm,$rfp\n";
    close(FILE);
    $monthly = "N/A";
    $fpratio = "N/A";
    $overall = "N/A";
  }

  $DATA{'HEADER'} = <<_end;
<TABLE BORDER=0 ALIGN=RIGHT>
<TR><TD>
  <TABLE BORDER=0>
  <TR><TD COLSPAN=2>Welcome, <I>$ENV{'REMOTE_USER'}</I>!</TD></TR>
  <TR><TD COLSPAN=2>It is <B>$time</B></TD></TR>
  <TR><TD>DSPAM has caught </TD><TD><B>$spam</B> spams</TD></TR>
  <TR><TD>...learned </TD><TD><B>$misses</B> spams</TD></TR>
  <TR><TD>...scanned </TD><TD><B>$innocent</B> innocent emails</TD></TR>
  <TR><TD>...with </TD><TD><B>$fp</B> false positives</TD></TR>
  <TR><TD>Your SPAM Ratio is</TD><TD><B>$ratio%</B></TD></TR>
  <TR><TD>Your SPAM Filtering Accuracy is</TD><TD><B>$monthly%</B> since last reset</TD></TR>
  <TR><TD>Your FP Rate is</TD><TD><B>$fpratio%</B> since last reset</TD></TR>
  <TR><TD>Your overall accuracy is</TD><TD><B>$overall%</B> since last reset</TD></TR>
  <TR><TD> &nbsp;</TD><TD><B>$sc</B> corpusfed spams</TD></TR>
  <TR><TD> &nbsp;</TD><TD><B>$ic</B> corpusfed nonspams</TD></TR>
  <TR><TD> &nbsp;</TD><TD><SMALL>($real_missed/$real_caught) SM <A HREF="$CONFIG{'ME'}?COMMAND=RESET_STATS">Reset Stats</A> | <A HREF="$CONFIG{'ME'}?COMMAND=TWEAK">Tweak -1</A></SMALL></TD></TR>
  <TR><TD> &nbsp;</TD><TD><SMALL>($real_fp/$real_innocent) FP</TD></TR>
  </TABLE>
</TD></TR>
</TABLE>
_end

  my($supp);
  my($f)=0; 
  open(FILE, "<$MAILBOX");
  while(<FILE>) {
    next unless (/^From /);
    $f++;
  }
  close(FILE);
  if ($f>0) { 
    $supp = qq!You have Quarantined Mail (<A HREF="$CONFIG{'ME'}?COMMAND=VIEW_SPAM">$f messages</A>)!;
  } else {
    $supp = "Your Quarantine is empty ($f messages)";
  }

  $DATA{'MESSAGE'} .= <<_end;
<B>My Quarantine</B><BR>
$supp<BR>
<BR>
<B>My FP Alerts:</B><BR>
<TABLE BORDER=0>
_end

  do {
    my($line) = 0;
    open(FILE, "<$USER.alerts");
    while(<FILE>) {
      s/</&lt;/g;
      s/>/&gt;/g;
      $DATA{'MESSAGE'} .= qq!<TR><TD>$_&nbsp;&nbsp;</TD><TD>[ <A HREF="$CONFIG{'ME'}?COMMAND=DELETE_ALERT&line=$line">Delete</A> ]</TD></TR>\n!;
      $line++;
    }
  }; 

$DATA{'MESSAGE'} .= <<_end;
</TABLE>
<FORM ACTION="$CONFIG{'ME'}">
<INPUT TYPE=HIDDEN NAME=COMMAND VALUE=ADD_ALERT>
<INPUT NAME=ALERT> &nbsp;<INPUT TYPE=SUBMIT VALUE="Add Alert">
</FORM>
<BR><BR>
&nbsp;&nbsp;If you have encountered a SPAM that was not caught by DSPAM 
please forward it to <A HREF="mailto:$CONFIG{'SPAM_ACCOUNT'}">$CONFIG{'SPAM_ACCOUNT'}</A> where it will be
contextually analyzed by our software and added to your statistical 
calculations.
_end

  &output(%DATA);
  exit;
}

sub output {
  print "Content-type: text/html\n\n";
  my(%DATA) = @_;
  open(FILE, "<template.html");
  while(<FILE>) { 
    s/\$([A-Z0-9]*)\$/$DATA{$1}/g; 
    print;
  }
  close(FILE);
  exit;
}

sub SafeVars {
  my(%PAIRS) = @_;
  my($url, $key);
  foreach $key (keys(%PAIRS)) {
    my($value) = $PAIRS{$key};
    $value =~ s/([^A-Z0-9])/sprintf("%%%x", ord($1))/gie;
    $url .= "$key=$value&";
  }
  $url =~ s/\&$//;
  return $url;
}

sub error {
  my($error) = @_;
  $DATA{'HEADER'} = "<B>AN ERROR HAS OCCURED</B>";
  $DATA{'MESSAGE'} = <<_end;
The following error occured while trying to process your request: <BR>
<B>$error</B><BR>
<BR>
If this problem persists, please contact your administrator.
_end
  &output(%DATA);
}

sub ReadParse {
  my(@pairs, %FORM);
  if ($ENV{'REQUEST_METHOD'} =~ /GET/i)
    { @pairs = split(/&/, $ENV{'QUERY_STRING'}); }
  else {
    my($buffer);
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
    @pairs = split(/\&/, $buffer);
  }
  foreach(@pairs) {
    my($name, $value) = split(/\=/, $_);

    $name =~ tr/+/ /;
    $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/<!--(.|\n)*-->//g;
    $FORM{$name} = $value;
  }
  return %FORM;
}
